package ch.SWITCH.aai.uApprove.components;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import org.opensaml.saml2.metadata.LocalizedString;

public class RequestedAttributeDescription {

	private String description = null;

	private Map<String, String> localizedDescMap = new HashMap<String, String>();

	public RequestedAttributeDescription() {
		;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public void putLocalizedDescription(LocalizedString description) {
		String lang = description.getLanguage();
		if (!localizedDescMap.containsKey(lang)) {
			localizedDescMap.put(lang, description.getLocalString());
		}
	}

	public Set<String> keySet() {
		return localizedDescMap.keySet();
	}

	public String getLocalizedDescription(String lang) {
		return localizedDescMap.get(lang);
	}

	public String getLocalizedDescription(Locale locale) {
		return localizedDescMap.get(locale.getLanguage());
	}

	public Map<String, String> getLocalizedDescMap() {
		return localizedDescMap;
	}
}
