package jp.gakunin.uApprovejp.saml2.metadata;

import java.util.List;

import javax.xml.namespace.QName;

import org.opensaml.common.SAMLObject;

public interface RequestedAttributeExtension extends SAMLObject {

	/** Local name of the Attribute element. */
	public static final String DEFAULT_ELEMENT_LOCAL_NAME = "RequestedAttributeExtension";

	/** Default element name. */
	public static final QName DEFAULT_ELEMENT_NAME = new QName(UApprovejpMetadata.NAMESPACE, DEFAULT_ELEMENT_LOCAL_NAME,
			UApprovejpMetadata.PREFIX);

	/** Local name of the XSI type. */
	public static final String TYPE_LOCAL_NAME = "RequestedAttributeExtensionType";

	/** QName of the XSI type. */
	public static final QName TYPE_NAME = new QName(UApprovejpMetadata.NAMESPACE, TYPE_LOCAL_NAME,
	        UApprovejpMetadata.PREFIX);

	/** Name of the FriendlyName attribute. */
	public static final String FRIENDLY_NAME_ATTRIB_NAME = "FriendlyName";

	/**
	 * Get the friendly name of this attribute.
	 * 
	 * @return the friendly name of this attribute
	 */
	public String getFriendlyName();

	/**
	 * Sets the friendly name of this attribute.
	 * 
	 * @param friendlyName the friendly name of this attribute
	 */
	public void setFriendlyName(String friendlyName);

	/**
	 * Gets the list of descriptions for this.
	 * 
	 * @return the list of descriptions for this.
	 */
	public List<Description> getDescriptions();

}
