/*
 * Copyright (c) 2010-2011, National Insutitute of Informatics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.gakunin.shibboleth.common.config.attribute.filtering.match.uapprove;

import edu.internet2.middleware.shibboleth.common.config.BaseSpringNamespaceHandler;

/**
 * Namespace handler for the attribute filter engine SAML match functions.
 */
public class UapproveMatchFunctorNamespaceHandler extends BaseSpringNamespaceHandler {

    /** Basic match function namespace. */
    public static final String NAMESPACE = "http://www.gakunin.jp/ns/uapprove-jp/afp/mf";

    /** {@inheritDoc} */
    public void init() {
        registerBeanDefinitionParser(AttributeUapproveMatchFunctorBeanDefinitionParser.SCHEMA_TYPE,
                new AttributeUapproveMatchFunctorBeanDefinitionParser());
    }
}
