<%@ page
	import="
  ch.SWITCH.aai.uApprove.viewer.Controller,
  ch.SWITCH.aai.uApprove.components.Attribute,
  ch.SWITCH.aai.uApprove.components.RelyingParty,
  ch.SWITCH.aai.uApprove.components.RequestedAttributeDescription,
  ch.SWITCH.aai.uApprove.components.ConsentMode,
  java.util.Map,
  java.util.List,
  java.util.Set,
  java.util.ArrayList,
  java.util.Collection,
  java.util.Iterator,
  java.util.Locale,
  java.util.ResourceBundle"%>


<%@ include file="header.jsp"%>


<%
  /*
 *------------------------------------------------------------------------------------
 *
 * attributes.jsp:
 * ----------
 *
 * Copyright (c) 2011, National Insutitute of Informatics
 * Copyright (c) 2005-2006 SWITCH - The Swiss Education & Research Network
 *
 *
 * Purpose: Webpage to show the user which attributes will be transfered to a resource.
 *          The user can accept or deny. In the latter case, he/she cannot of course 
 *          access the resource. 
 * 
 * 
 * Usage: This page is invoked from the servlet Controller of the package
 *        ch.SWITCH.aai.uApprove.viewer. 
 * 
 * Note: 
 * This JSP page uses the classes AttributeDumper and AttributeDescription to display the
 * attributes.
 * 
 * Author: C.Witzig
 * Date: 2.3.2006
 * 
 *
 *
 * Modifications:
 *---------------
 * 1. fixed bug in extracting resource host if there is no second '/'. Dec 22, 2006
 * 2. changed replace with replaceAll in convertAttributeValue such that it compiles with 1.4.2
 *    (courtesy of Jon Warwick, University of Cambridge)
 *    ChW June 18, 2007
 * 
 * 
 *--------------------------------------------------------------------------------------
 */
%>

<%!
  public String safeTip(String input) {
    return input.replace("\"","&quot;").replace("'","&#39;").replace("\n"," ");
  }
%>


<%
  RelyingParty relyingParty = (RelyingParty) session.getAttribute(Controller.SESKEY_RELYINGPARTY);
  boolean globalConsentPosibble = (Boolean) session.getAttribute(Controller.SESKEY_GLOBAL_CONSENT_POSSIBLE);
  ConsentMode consentMode = (ConsentMode) session.getAttribute(Controller.SESKEY_ATTRIBUTES_CONSENT_MODE);
  List<Attribute> attributes = (List<Attribute>) session.getAttribute(Controller.SESKEY_ATTRIBUTES);
  Locale locale = (Locale) session.getAttribute(Controller.SESKEY_LOCALE);

  ResourceBundle rb = ResourceBundle.getBundle( Controller.RB_ATTRIBUTES, locale);
  out.println( "<p><strong>" + (String) rb.getString("title") + "</strong></p>" );

  Map<String, RequestedAttributeDescription> reqdAttrDescs = Controller.getReqdAttrDescs(relyingParty);
  String mandatoryAttrIds = (String) session.getAttribute(Controller.SESKEY_MANDATORY_ATTRIBUTES);
  String selectedAttrIds = (String) session.getAttribute(Controller.SESKEY_SELECTED_ATTRIBUTES);
  String blacklistedAttrIds = (String) session.getAttribute(Controller.SESKEY_BLACKLISTED_ATTRIBUTES);

  List<Attribute> mandatoryAttrs = new ArrayList<Attribute>();
  List<Attribute> optionalAttrs = new ArrayList<Attribute>();
  List<Attribute> blacklistedAttrs = new ArrayList<Attribute>();

  for (Attribute attribute: attributes) {
    String attrId = attribute.attributeID;

    Collection<String> values = attribute.attributeValues;
    if ( values == null || values.isEmpty() ) {
      continue;
    }

    if (Attribute.compareAttributeRelease(blacklistedAttrIds, attrId)) {
      blacklistedAttrs.add(attribute);
    } else if (Attribute.compareAttributeRelease(mandatoryAttrIds, attrId)) {
      mandatoryAttrs.add(attribute);
    } else {
      optionalAttrs.add(attribute);
    }
  }

	// --------------------- Attribute Release table  ------------------- 

	String sTxtExpl = (String) rb.getString( "txt_explanation" );
		
	sTxtExpl = sTxtExpl.replaceFirst( "\\?",
			"<tt onmouseover=\"Tip('"+safeTip(Controller.getRelyingPartyDesc(relyingParty, locale))+"')\" onmouseout=\"UnTip()\">"
			+ Controller.getRelyingPartyName(relyingParty, locale)
			+ "</tt>");

	out.println("<p>" + sTxtExpl + "</p>" );
%>




<!--- ------------------ table with the attributes ------------------ -->
<script type="text/javascript" src="scripts/radio.js"></script>
<script type="text/javascript" src="scripts/wz_tooltip.js"></script>

<form name="question" action="Controller">
<center>
<table cellpadding="0" cellspacing="0">
	<tr>
		<td>
		<table width="570" id="card" cellpadding="0" cellspacing="0">
			<tr>
				<td id="idcardTitle" colspan="2"><%=(String) rb.getString("txt_idcard_title")%></td>
			</tr>
	<%
	// iterate over the attributes
	int i = 0;
	for (Attribute attribute: mandatoryAttrs) {
      String attrId = attribute.attributeID;

      RequestedAttributeDescription reqdAttrDesc = reqdAttrDescs.get(attribute.attributeFriendlyName);
      String attrDesc = null;
      if (reqdAttrDesc != null) {
      	attrDesc = reqdAttrDesc.getLocalizedDescription(locale);
      	if (attrDesc == null) {
    	  attrDesc = reqdAttrDesc.getDescription();
      	}
      }

      Collection<String> values = attribute.attributeValues;
      String valuesHtml = "";
      for (String value : values) {
        valuesHtml += value + "<br />";
      }
      if (i == 0) {
    %>
			<tr>
				<td class="attr-usage" colspan="2"><%=(String) rb.getString("txt_mandate_attrs")%></td>
			</tr>
    <%
      }
    %>
			<tr bgcolor='<%= i++ % 2 == 0 ? "white" : "#eeeeee" %>'>
				<td class="attr-name-mandate">
				<input type="hidden" name="<%=Controller.GETPAR_RELEASED_ATTRIBUTES%>" value="<%=attrId + "=" + Attribute.digest(valuesHtml.replace("<br />", ";"))%>">
				<span onmouseover="Tip('<%=safeTip(Controller.resolveDisplayDesc(attribute, locale))%>')"
					onmouseout="UnTip()">
				<%=Controller.resolveDisplayName(attribute, locale)%>
				</span>
				<%if (attrDesc != null) out.print("<span onmouseover=\"Tip('"+attrDesc+"')\" onmouseout=\"UnTip()\">?</span>");%>
				</td>
				<td class="attr-value"><%= valuesHtml.replace("$","<br />") %></td>
			</tr>
	<%
    }

	// iterate over the attributes
	i = 0;
	for (Attribute attribute: optionalAttrs) {
      String attrId = attribute.attributeID;

      RequestedAttributeDescription reqdAttrDesc = reqdAttrDescs.get(attribute.attributeFriendlyName);
      String attrDesc = null;
      if (reqdAttrDesc != null) {
      	attrDesc = reqdAttrDesc.getLocalizedDescription(locale);
      	if (attrDesc == null) {
    	  attrDesc = reqdAttrDesc.getDescription();
      	}
      }

      Collection<String> values = attribute.attributeValues;  
      String valuesHtml = "";
      for (String value : values) {
        valuesHtml += value + "<br />";
      }
      if (i == 0) {
      %>
			<tr>
				<td class="attr-usage" colspan="2"><%=(String) rb.getString("txt_optional_attrs")%></td>
			</tr>
      <%
      }
      %>
			<tr bgcolor='<%= i++ % 2 == 0 ? "white" : "#eeeeee" %>'>
				<td class="attr-name-option">
				<input type="checkbox" name="<%=Controller.GETPAR_RELEASED_ATTRIBUTES%>" value="<%=attrId + "=" + Attribute.digest(valuesHtml.replace("<br />", ";"))%>"
				    <%if (Attribute.compareAttributeRelease(selectedAttrIds, attrId)) out.print("checked");%>>
				<input type="hidden" name="<%=Controller.GETPAR_RELEASED_ATTRIBUTES%>" value="<%=attrId + "=" + Attribute.digest(valuesHtml.replace("<br />", ";"))%>" disabled="disabled">
				<span onmouseover="Tip('<%=safeTip(Controller.resolveDisplayDesc(attribute, locale))%>')"
					onmouseout="UnTip()">
				<%=Controller.resolveDisplayName(attribute, locale)%>
				</span>
				<%if (attrDesc != null) out.print("<span onmouseover=\"Tip('"+attrDesc+"')\" onmouseout=\"UnTip()\">?</span>");%>
				</td>
				<td class="attr-value"><%= valuesHtml.replace("$","<br />") %></td>
			</tr>
	  <%
    }
%>
		</table>
		</td>
		<td class="card-shadow" valign="top">
		<div id="noshadow-tr"></div>
		</td>
	</tr>
	<tr>
		<td class="card-shadow" align="left">
		<div id="noshadow-bl"></div>
		</td>
		<td class="card-shadow"></td>
	</tr>
</table>
<%
    for (Attribute attribute: blacklistedAttrs) {
      String attrId = attribute.attributeID;
      %>
      <input type="hidden" name="<%=Controller.GETPAR_RELEASED_ATTRIBUTES%>" value="<%=attrId%>">
      <%
    }
%>

</center>

<!--- --------------------- Ask for user consent ------------------- -->

<%
	out.println("<p>" + (String) rb.getString( "txt_cross_boxes" ) + "</p>" );
%>

<div class="login-field">
<p class="consent-mode"><input type="radio"
	name="<%=Controller.GETPAR_ATTRIBUTES_CONSENT_MODE%>"
	value="<%=ConsentMode.CHECK_ALWAYS%>" onClick="selectable_optionalAttributes(true)"
	<% if (consentMode == ConsentMode.CHECK_ALWAYS) { %>
	checked
	<% } %>
	>
<%=rb.getString( "txt_mode_a" )%></p>
<p class="consent-mode"><input type="radio"
	name="<%=Controller.GETPAR_ATTRIBUTES_CONSENT_MODE%>"
	value="<%=ConsentMode.THE_SERVICE%>" onClick="selectable_optionalAttributes(true)"
	<% if (consentMode == ConsentMode.THE_SERVICE) { %>
	checked
	<% } %>
	>
<%=rb.getString( "txt_mode_b" )%></p>
<%
	if ( globalConsentPosibble ) {
%>
<p class="consent-mode"><input type="radio"
	name="<%=Controller.GETPAR_ATTRIBUTES_CONSENT_MODE%>"
	value="<%=ConsentMode.GLOBAL%>" onClick="selectable_optionalAttributes(false)"
	<% if (consentMode == ConsentMode.GLOBAL) { %>
	checked
	<% } %>
	>
<%=rb.getString( "txt_mode_c" ) %></p>
<% } %>
<div align="right">
<p><input type="submit"
	name="<%= Controller.GETPAR_ATTRIBUTES_CANCEL %>"
	value='<%=rb.getString( "label_cancel") %>'> <input
	type="submit" name="<%=Controller.GETPAR_ATTRIBUTES_NEXT%>"
	value='<%=rb.getString( "label_next") %>'></p>
</div>
</div>
</form>

<br>
<center><%= rb.getString( "txt_comment" ) %></center>

<%@ include file="footer.jsp"%>
